routes/web.php
<?php

use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::middleware(['lang'])->group(function () {

    // home page
    Route::get('/', 'HomeController@index')->name('home');
    // admin rout
    Route::group(['namespace' => 'Admin', 'prefix' => 'admin', 'as' => 'admin.'], function () {
        Route::get('login', 'LoginController@login')->name('login');
        Route::post('login', 'LoginController@loginPost')->name('loginPost');
        Route::post('logout', 'LoginController@logout')->name('logout');
        // admin check
        Route::group(['middleware' => ['auth', 'AdminCheck']], function () {
            Route::get('/', 'DashboardController@dashboard')->name('home');
            Route::get('settings', 'DashboardController@settings')->name('settings');
            Route::post('settings', 'DashboardController@settingsPost');
            Route::resources([
                'users' => 'UserController',
                'roles' => 'RoleController',
                'sliders' => 'SliderController',
                'categories' => 'CategoryController',
                'services' => 'ServiceController',
                'payments' => 'PaymentController',
                'rates' => 'RateController',
                'contacts' => 'ContactController',
                'posts' => 'PostController',
            ]);

            Route::get('activities/user/{id}', 'LoggingController@userActivities')->name('activities');
            Route::get('activities/{id}', 'LoggingController@userActivity')->name('show_activity');
    });
  });

    // vendor
    Route::group(['namespace' => 'Vendor', 'prefix' => 'vendor', 'as' => 'vendor.'], function () {
        Route::get('login', 'LoginController@login')->name('login');
        Route::post('login', 'LoginController@loginPost')->name('loginPost');;
        Route::post('logout', 'LoginController@logout')->name('logout');

        Route::group(['middleware' => ['auth', 'VendorCheck']], function () {
            Route::get('/', 'DashboardController@dashboard')->name('home');
            Route::get('settings', 'DashboardController@settings')->name('settings');
            Route::post('settings', 'DashboardController@settingsPost');
            Route::resources([
                'users' => 'UserController',
                'posts' => 'PostController',
            ]);
        });
    });

});

app/Models/Role.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Role extends Model
{
    protected $fillable = [
        'name','guard_name'
    ];
}

app/Http/Controllers/Admin/RoleController.php
<?php

namespace App\Http\Controllers\Admin;


use App\Models\User;
use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use Spatie\Permission\Models\Permission;
use Spatie\Permission\Models\Role;

class RoleController extends Controller
{

    public function __construct()
    {
        $this->middleware(['permission:roles management']);
    }

    /**
     * Display a listing of the Role.
     *
     * @param Request $request
     *
     * @return Response
     */
    public function index(Request $request)
    {
        $roles = new Role();
        $roles = $roles->get();
        return view('admin.roles.index', ['roles' => $roles]);
    }

    /**
     * Show the form for creating a new Role.
     *
     * @return Response
     */
    public function create()
    {
        return view('admin.roles.create');
    }

    /**
     * Store a newly created Role in storage.
     *
     * @param Request $request
     *
     * @return Response
     */
    public function store(Request $request)
    {
        $validate = $request->validate([
            'name' => 'required',
        ]);

        $role = new Role();
        $role->name = request('name');
        $role->guard_name = "web";
        $role->Save();


        if($request->permissions) {
            foreach ($request->permissions as $permission) {
                Permission::findOrCreate($permission);
                $role->givePermissionTo($permission);
            }
        }

        return redirect()->route('admin.roles.index')->with('success', __('Roles saved successfully.'));
    }

    /**
     * Display the specified Role.
     *
     * @param int $id
     *
     * @return Response
     */
    public function show($id)
    {
        $role = Role::findOrFail($id);
        return view('admin.roles.show', ['role' => $role]);
    }

    /**
     * Show the form for editing the specified Role.
     *
     * @param int $id
     *
     * @return Response
     */
    public function edit($id)
    {
        $role = Role::findOrFail($id);

        return view('admin.roles.edit')->with('role', $role);
    }

    /**
     * Update the specified Role in storage.
     *
     * @param int $id
     * @param Request $request
     *
     * @return Response
     */
    public function update($id, Request $request)
    {
        $validate = $request->validate([
            'name' => 'required',
        ]);

        $role = Role::find($id);

        foreach ($role->permissions->whereNotIn('name', $request->permissions) as $permission) {
            $role->revokePermissionTo($permission);
        }

        if($request->permissions) {
            foreach ($request->permissions as $permission) {
                Permission::findOrCreate($permission);
                $role->givePermissionTo($permission);
            }
        }

        return redirect()->route('admin.roles.index')->with('success', __('Roles updated successfully.'));
    }

    /**
     * Remove the specified Role from storage.
     *
     * @param int $id
     *
     * @return Response
     * @throws \Exception
     *
     */
    public function destroy($id)
    {
        $role = Role::findOrFail($id);
        $role->delete($id);
        return redirect()->route('admin.roles.index')->with('success', __('Roles deleted successfully.'));
    }
}

resources/views/admin/roles/create.blade.php
@extends('admin.layouts.app')

@section('title', 'Dashboard')

@section('css')
    <style>

    </style>
@endsection

@section('content')

    <div class="card">
        <div class="card-header header-elements-inline">
            <h5 class="card-title">{{__('Create roles')}}</h5>
        </div>

        <div class="card-body">
            <form action="{{route('admin.roles.store')}}" method="post" enctype="multipart/form-data">
                @csrf
                <div class="card-body">
                    <div class="tab-content">
                        <div class="tab-pane fade show active" id="tab1">
                            <div class="form-group row">
                                <label class="col-form-label col-lg-2">{{__('Name')}}</label>
                                <div class="col-lg-10">
                                    <input type="text" class="form-control" name="name" value="{{old('name')}}">
                                </div>
                            </div>
                        </div>
                    </div>

                    <hr>

                    <div class="tab-content">
                        <label class="col-form-label">{{__('Permissions')}}</label>
                        <div class="row">

                            @foreach(\App\Models\User::perms() as $key => $permission)
                                <div class="col-md-6">
                                    <div class="row">
                                            <div class="col-md-4">
                                                <label>
                                                    <input type="checkbox" name="permissions[]"
                                                           value="{{$permission}}">
                                                    {{__($permission)}}
                                                </label>
                                            </div>
                                    </div>
                                </div>
                            @endforeach
                        </div>
                    </div>

                    <div class="text-right">
                        <button type="submit" class="btn btn-primary">Submit <i class="icon-paperplane ml-2"></i>
                        </button>
                    </div>
            </form>
        </div>
    </div>


@endsection


@section('js_code')
    <script>
        $('.addImage').click(function () {
            $('.imageInputs').append(`
             <div class="form-group row">
                    <label class="col-form-label col-lg-2">{{__('Images')}}</label>
                    <div class="col-lg-10">
                        <input type="file" class="form-control" name="image[]">
                    </div>
                </div>
            `)
        });
    </script>
@endsection

resources/views/admin/roles/edit.blade.php
@extends('admin.layouts.app')

@section('title', 'Dashboard')

@section('content')

    <div class="card">
        <div class="card-header header-elements-inline">
            <h5 class="card-title">{{__('Edit roles')}}</h5>
        </div>

        <div class="card-body">
            <form action="{{route('admin.roles.update',$role->id)}}" method="post" enctype="multipart/form-data">
                @csrf
                @method('PUT')
                <div class="card-body">
                    <div class="tab-content">
                        <div class="tab-pane fade show active" id="tab1">
                            <div class="form-group row">
                                <label class="col-form-label col-lg-2">{{__('Name')}}</label>
                                <div class="col-lg-10">
                                    <input type="text" class="form-control" name="name" value="{{$role->name}}">
                                </div>
                            </div>
                        </div>
                    </div>

                    <hr>

                    <div class="tab-content">
                        <label class="col-form-label">{{__('Permissions')}}</label>
                        <div class="row">

                            @foreach(\App\Models\User::perms() as $key => $permission)
                                <div class="col-md-6">
                                    <div class="row">
                                            <div class="col-md-4">
                                                <label>
                                                    <input {{$role->hasPermissionTo($permission) ? 'checked' : ''}} type="checkbox" name="permissions[{{$permission}}]" value="{{$permission}}">
                                                    {{__($permission)}}
                                                </label>
                                            </div>
                                    </div>
                                </div>
                            @endforeach
                        </div>
                    </div>

                    <div class="text-right">
                        <button type="submit" class="btn btn-primary">Submit <i class="icon-paperplane ml-2"></i>
                        </button>
                    </div>
            </form>
            </form>
        </div>
    </div>


@endsection


@section('js_code')

@endsection

resources/views/admin/roles/index.blade.php
@extends('admin.layouts.app')

@section('title', 'Dashboard')

@section('css')
    <style>

    </style>
@endsection


@section('page-header')
    <!-- Role header -->
    <div class="page-header page-header-light">
        <div class="page-header-content header-elements-md-inline">
            <div class="page-title d-flex">
                <h4><i class="icon-arrow-left52 mr-2"></i> <span class="font-weight-semibold">{{__('Home')}}</span>
                    - {{__('Roles')}}</h4>
                <a href="#" class="header-elements-toggle text-default d-md-none"><i class="icon-more"></i></a>
            </div>
        </div>
        <div class="breadcrumb-line breadcrumb-line-light header-elements-md-inline">
            <div class="d-flex">
                <div class="breadcrumb">
                    <a href="{{route('admin.home')}}" class="breadcrumb-item"><i
                            class="icon-home2 mr-2"></i> {{__('Home')}}</a>
                    <span class="breadcrumb-item active">{{__('Roles')}}</span>
                </div>

            </div>

        </div>
    </div>
    <!-- /page header -->
@endsection

@section('content')

    <a type="button" class="btn bg-success mb-2"
       href="{{route('admin.roles.create')}}">{{__('Add new role')}} <i
            class="icon-plus3 ml-2"></i></a>


    <!-- Basic table -->
    <div class="card">
        <div class="card-header header-elements-inline">
            <h5 class="card-title">{{__('Roles')}}</h5>
        </div>


        <form class="form-group row p-2">
            <div class="col-lg-10">
                <div class="row">
                    <div class="col-md-4">
                        <span class="form-text text-muted text-center">{{__('Role name')}}</span>
                        <input type="text" name="page_name" class="form-control" value="{{request('role_name')}}">
                    </div>

                    <div class="col-md-4">
                        <span class="form-text text-muted text-center"> &nbsp;</span>
                        <input type="submit" value="Search" class="btn btn-success">
                    </div>
                </div>
            </div>
        </form>

        <div class="table-responsive">
            <table class="table">
                <thead>
                <tr>
                    <th>#</th>
                    <th>{{__('Name')}}</th>
                    <th>{{__('Permissions')}}</th>
                    <th>{{__('Users')}}</th>
                    <th>{{__('Action')}}</th>
                </tr>
                </thead>
                <tbody>
                @foreach($roles as $role)
                    <tr>
                        <td>{{$role->id}}</td>
                        <td>{{$role->name}}</td>
                        <td> {{ $role->permissions->count() }} </td>
                        <td><a href="{{route('admin.users.index',['role_id' => $role->id ])}}">{{ $role->users->count() }}</a></td>
                        <td width="150">
                            <a class="btn btn-sm btn-info d-inline"
                               href="{{route('admin.roles.edit',$role->id)}}"><i
                                    class="icon-pencil7"></i></a>
                            <form method="POST" action="{{route('admin.roles.destroy',$role->id)}}"
                                  class="d-inline">
                                @method('DELETE')
                                @csrf
                                <button type="submit" class="btn btn-sm btn-danger"
                                        onclick="return confirm('Are you sure?')"><i class="icon-trash-alt"></i>
                                </button>
                            </form>
                        </td>
                    </tr>
                @endforeach

                </tbody>
            </table>
        </div>

    </div>
    <!-- /basic table -->

@endsection


@section('js')

@endsection